#version 330 core

out vec4 FragColor;

in vec2 TexCoord;
in vec2 BTexCoord;
in vec4 Color;
in vec4 Viewport;
in mat4 ProjInv;
in vec4 FogColor;
in vec2 FogStartEnd;
in float FogFactor;
in float DistanceToCamera;
flat in int IsFogg;

uniform sampler2D atlas;
uniform sampler2D lightTex;
uniform sampler2D noiseTexture;

float getNoise(vec2 uv) {
	return texture(noiseTexture, uv).r;
}

void main()
{
	vec4 texColor = texture(atlas, TexCoord);
	vec4 colorMult = Color / 256.0;
	vec4 lightyColor = texture(lightTex, (BTexCoord + 8.0) / 256.0);

	vec4 rasterColor =
#ifdef PASS_0
	vec4((texColor.xyz * colorMult.xyz) * lightyColor.xyz, texColor.w);
#else
	(texColor * colorMult) * lightyColor;
#endif

	FragColor = vec4(mix(FogColor.xyz, rasterColor.xyz, FogFactor), rasterColor.w);

/*	if(IsFogg == 1) {
		float noiseScale = 0.004;

		vec2 noiseUV = vec2(DistanceToCamera * noiseScale, DistanceToCamera * noiseScale);

		float fogNoise = getNoise(noiseUV);

		float finalFogFactor = FogFactor * fogNoise;

		FragColor = vec4(mix(rasterColor.rgb, FogColor.rgb, finalFogFactor), rasterColor.a);
	} else {
		FragColor = rasterColor;
	}*/
}
